
function adler32a(adler, buf, len, pos) {
	var s1 = (adler & 0xffff) |0,
	s2 = ((adler >>> 16) & 0xffff) |0,
	n = 0;

	while (len !== 0) {
		// Set limit ~ twice less than 5552, to keep
		// s2 in 31-bits, because we force signed ints.
		// in other case %= will fail.
		n = len > 2000 ? 2000 : len;
		len -= n;

		do {
			s1 = (s1 + buf[pos++]) |0;
			s2 = (s2 + s1) |0;
		} while (--n);

		s1 %= 65521;
		s2 %= 65521;
	}

	return (s1 | (s2 << 16)) |0;
}
function adler32b(buf) {
	var M
	, MOD = 65521
	, a = 1
	, b = 0
	, i = 0
	, len = buf.length

	for (; i < len; ) {
		M = Math.min(len - i, 3850) + i
		for (; i < M; ) {
			a += buf[i++]
			b += a
		}
		a = (15*(a>>>16)+(a&65535))
		b = (15*(b>>>16)+(b&65535))
	}
	return ((b % MOD) << 16) | (a % MOD)
}





