

!function(exports) {
	var c, k
	, n = 0
	, table = []

	exports.crc32 = crc32

	for (; n < 256; ) {
		c = n
		for (k = 0; k < 8; k++) {
			c = c & 1 ? (0xEDB88320 ^ (c >>> 1)) : c >>> 1
		}
		table[n++] = c
	}

	function crc32(crc, buf, len, pos) {
		var t = table
		, i = pos
		, end = pos + len

		for (crc ^= -1; i < end; ) {
			crc = (crc >>> 8) ^ t[(crc ^ buf[i++]) & 0xFF]
		}

		return crc^-1
	}



/*


	var makeCRCTable = function(){
		var c;
		var crcTable = [];
		for(var n =0; n < 256; n++){
			c = n;
			for(var k =0; k < 8; k++){
				c = (c&1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1)
			}
			crcTable[n] = c;
		}
		return crcTable;
	}

	var crc32 = function(str) {
		var crcTable = window.crcTable || (window.crcTable = makeCRCTable());
		var crc = 0 ^ (-1);

		for (var i = 0; i < str.length; i++ ) {
			crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xFF];
		}

		return (crc ^ (-1)) >>> 0;
	};
	*/

	function reverse(x, n) {
		for (var b = 0; n--;) {
			b = b * 2 + x % 2
			x /= 2
			x -= x % 1
		}
		return b
	}

	function makeTable() {

		return table;
	}
	function makeTable(polynomial) {
		var i, j, c, tbl = []
		, rev = reverse(polynomial, 32)

		for (i = 256; i--; ) {
			c = i

			for (j = 8; j--; ) {
				c = (c&1) ? (rev ^ (c >>> 1)) : (c >>> 1)
			}

			tbl[i] = c
		}
		return tables[polynomial] = tbl
	}

	var undef;

	//function crc(s/*, polynomial = 0x04C11DB7, initialValue = 0xFFFFFFFF, finalXORValue = 0xFFFFFFFF*/) {
	function crc(polynomial, s, initialValue, finalXORValue) {
		s += ""

		var i = 0
		, crc = initialValue === undef ? -1 : initialValue
		, table = tables[polynomial] || makeTable(polynomial)

		for (; i < s.length; i++) {
			crc = (crc>>>8) ^ table[ 0xFF & (crc ^ s.charCodeAt(i)) ]
		}

		return (crc ^ (finalXORValue === undef ? -1 : finalXORValue)) >>> 0
	}

	root.crc32 = crc.bind(null, 0x04C11DB7)//, 0xFFFFFFFF, 0xFFFFFFFF)
	root.crc = crc



// Create table on load. Just 255 signed longs. Not a problem.
var crcTable = makeTable();


function crc32(crc, buf, len, pos) {
  var t = crcTable,
      end = pos + len;

  crc ^= -1;

  for (var i = pos; i < end; i++) {
    crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
  }

  return (crc ^ (-1)); // >>> 0;
}


module.exports = crc32;

}(this)

/*
console.log(String.crc32('test').toString(16), "D87F7E0C")
console.log(String.crc32('test', 0x04c11db7, 0, 0xFFFFFFFF).toString(16), "6C45EEF")
console.log(String.crc32('test', 0x04c11db7, 0xFFFFFFFF, 0).toString(16), "278081F3")
console.log(String.crc32('test', 0x04c11db7, 0, 0).toString(16), "F93BA110")
*/

/** Tests

TestCase("CRC").compare(
	String.crc32('test').toString(16)
, "d87f7e0c"
, "String.crc32()"
).done()

//*/


