

!function(serviceWorker, appCache, View) {
	var UPDATE = "app:update"
	, UPDATEREADY = "app:updateready"

	if (serviceWorker) {
		serviceWorker.addEventListener("message", function(event) {
			View.emit(event.data.op || event.data, event.data)
		})
		serviceWorker.register("worker.js").then(function(reg) {
			View.on(UPDATE, reg.update, reg)
			var worker = reg.installing || reg.waiting || reg.active
			if (worker) worker.onstatechange = function(event) {
				if (event.target.state === "redundant") {
					View.emit(UPDATEREADY)
				}
			}
		})
	} else if (appCache) {
		View.on(UPDATE, appCache.update, appCache)
		appCache.addEventListener("updateready", onUpdateReady)
		onUpdateReady()
	}

	function onUpdateReady() {
		if (appCache.status == 4) {
			View.emit(UPDATEREADY)
		}
	}
}(navigator.serviceWorker, this.applicationCache, View)


// if (confirm("A new version of this site is available. Load it?"))
// if (confirm("A new version is available. Load it?"))

/*
- url: /(.*\.(appcache|manifest))
  static_files: \1
  mime_type: text/cache-manifest
  upload: (.*\.(appcache|manifest))
  expiration: "0s"
*/

