

var VERSION = "2018-09-17T09:42:42.594Z"
, cacheList = [
	VERSION
]
, isFileRe = /\/[-\.\w]+\.\w+$/

function log() {
	//console.log.apply(console.log, arguments)
}

self.addEventListener("install", function(event) {
	log("install", VERSION)
	event.waitUntil(
		fetch("cache.manifest", { cache: "no-store" })
		.then(function(res) {
			return res.text().then(function(text) {
				return caches.open(VERSION)
				.then(function(cache) {
					var files = text.match(/^(?![#*]|CACHE MANIFEST|\w+:)[^\n\r]+/gm)
					log("cache.addAll", files)
					return cache.addAll(files)
				})
			})
		})
		.then(self.skipWaiting)
	)
})

self.addEventListener("activate", function(event) {
	log("activate", VERSION)
	event.waitUntil(
		caches.keys()
		.then(function(keys) {
			return Promise.all(keys.map(function(key) {
				if (cacheList.indexOf(key) < 0) {
					log("caches.delete", key)
					return caches.delete(key)
				}
			}))
		})
	)
})


self.addEventListener("fetch", function(event) {
	var url = event.request.url.slice(self.registration.scope.length).split("?")[0] || "index.html"

	if (
		event.request.method === "GET" &&
		isFileRe.test(url)
	) event.respondWith(
		caches.open(VERSION)
		.then(function(cache) {
			return cache.match(url, { ignoreSearch: true })
			.then(function(response) {
				if (!response) log("MISS", url)
				return response || fetch(event.request)
			})
		})
	)
})

self.addEventListener("message", function(event) {
	var op = event.data.op || event.data
	if (op === "update") {
		//event.source.postMessage("Responding to " + event.data)
	}
})




